(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
    Editeur de polices ASCII destines au mode texte (03h). L'interface     
 utilise la souris et le clavier.                                           
                                                                            
        Entrez F1 pour obtenir les fonctions offertes par le clavier        
Ĵ
  Fichiers ncessaires                                                    
                                                    
                                                                            
 -> 'Edit16x8.Pcx' : Image de fond                                          
 -> 'EditSauv.Pcx' : Image de sauvegarde                                    
 -> 'Oui_Non.Pcx'  : Image de demande de confirmation                       
 -> 'Rom16x8.Inc'  : Police ASCII par dfaut                                
                                                                            
Ĵ
  Version    Consultez le fichier 'UNITE\A-Lire.txt' pour comprendre      
    les caractres dbutant les lignes.                          
                                                                            
 01/12/1998 => Version 1.0 (dbut d'inscription des modifications)          
 02/12/1998 => Version 1.0.1                                                
    * Utilisation de constantes pour l'envoi des fonctions vers la procdure
      'Bouton'.                                                             
 28/12/1998 => Version 1.0.2                                                
    ! Dbogage de la procdure 'SauveFNT' et 'EcritNomFich'                 
 14/02/1998 => Version 1.0.3                                                
    * Utilisation des units EcranTxt et Clavier                            
    ! Debogage de la procdure 'Fin' -> Attend l'cran aprs avoir          
      rinitialiser la varte vido en mode texte pour viter un sursautement
 17/02/1998 => Version 1.0.4                                                
    * Changement de l'image de fond de l'interface                          
 01/03/1999 => Version 1.0.5                                                
    ! Inversion des touches gauches et droites (anciennement  l'envers)    
    + Ajout des fonctions 'Copier' et 'Coller'                              
 02/03/1999 => Version 1.0.6                                                
    + Ajout d'un second petit caractre pour voir le caractre stock en    
      mmoire                                                               
 07/03/1999 => Version 1.0.7                                                
    * Utilisation des touches C,R et V (Tapez F1 pour leur signification    
    + Sauvegarde automatique du fichier s'il a t modifi, donc:           
    + Ajout de la procdure 'AsciiMisAJour'                                 
*)

{$M 4096,0,65535}
{-$DEFINE FinRapide: Fin rapide (pas de confirmation ni de fondu)            }

uses
  Clavier,    { Interface utilisateur                                        }
  DrvSouri,   { Gestion de base de la souris                                 }
  EcranTxt,   { Gestion du mode texte en couleur                             }
  EcranVga,   { Gestion du mode VGA (13h : 320x200 pixels en 256 couleurs)   }
  GestStrg,   { Gestion des chaines de caractres                            }
  GestFich,   { Gestion de fichiers : Ouverture, cration, taille, erreur,...}
  PalVideo,   { Gestion de la palette de la couleur (fondu mode VGA/texte)   }
  PolicTxt,   { Gestion de la police de caractre 16x8 pixels (noir et blanc)}
  PCX,        { Affiche d'image au format PCX                                }
  SouriVGA;   { Gestion de la souris en mode VGA                             }

const
  Version = '1.0.7';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.haypo.fr.st/';

type
  EnteteFNT = record
    ID : Array[0..2] of char;
    Version: Array[0..1] of char;
    Hauteur,Largeur    : byte;
    BitParPixel        : byte;
  end;

const
  { En-tte des fichiers police }
  EnTeteFNTok : EnTeteFNT = (
    ID         : ('F','N','T');          { Identif : FNT  }
    Version    : ('1','0');              { Version : 1.0  }
    Hauteur    : 16; Largeur    : 8;     { Taille  : 16x8 }
    BitParPixel: 1);                     { Un bit/pixel   }

  { Interface }
  IndexDefaut = Ord('A');
  _CLAVIER  = 0;
  _SOURIS_G = 1;
  _SOURIS_D = 2;

  _CHANGM1  =   0;
  _CHANGM10 =   1;
  _CHANGP1  =   2;
  _CHANGP10 =   3;
  _NOUVEAU  =  10;
  _OUVRIR   =  11;
  _SAUVER   =  12;
  _SAUVSOUS =  13;
  _COPIER   =  14;
  _COLLER   =  15;
  _EFFACE   =  20;
  _DEFAUT   =  21;
  _QUITTER  = 255;

  { Position }
  ConfirmX = (320-100) shr 1;
  ConfirmY = (200-50)  shr 1;
  OuiX = ConfirmX+9;  OuiY = ConfirmY+31; OuiLarg = 33; OuiHaut = 13;
  NonX = ConfirmX+50; NonY = ConfirmY+31; NonLarg = 42; NonHaut = 13;

  GrdChrX  = 2; GrdChrY = 2;           { Position du grand caractre }
  PtiChrX  = 80; PtiChrY  = 10;        { Position du petit caractre }
  PtiChrCX = 80; PtiChrCY = 30;        { Position du petit caractre copi }

  SauvLarg = 120; SauvHaut = 33;
  SauvX = (320-SauvLarg) shr 1;
  SauvY = (200-SauvHaut) shr 1;
  SauvTitrX = SauvX+11; SauvNomX = SauvX+11;
  SauvTitrY = SauvY+6;  SauvNomY = SauvY+18;

  { Couleurs }
  Gris  = 23;
  Jaune = 71;
  Bleu  = 17;
  Rouge = 111;
  NomFichCoulFond = 24;
  SauveCoulFond   = NomFichCoulFond;
  CoulOui = Jaune;
  CoulNon = Bleu;

  { Reste }
  MasqueB: array [0..7] of byte = (128,64,32,16,8,4,2,1);
  OUI = TRUE;
  NON = FALSE;

var
  EnTete: EnteteFNT;
  AsciiDemarrage,Ascii,SauveAscii: PoliceAscii16x8;
  Tampon: Array[0..100*50-1] of byte;
  Pal   : array[0..256*3-1]  of byte;
  SauveChr: Caract16x8;

  NomFichCours: String;

  { Couleur }
  CoulCours : array[1..2] of boolean;
  blanc,noir: byte;
  CoulCh: array [0..1] of byte;

  AsciiIndex: byte;
  done :boolean;

  key: char;
  Txt: string;

  i,ix,iy, index,vram: word;
  coul,CoulF: byte;

  f : file;
  erreur : word;

procedure Coloriz (on: boolean); begin
  EffaceSouris;

  if on then begin
    coul  := jaune;
    CoulF := bleu;
  end else begin
    coul  := bleu;
    CoulF := jaune;
  end;

  { Colorie le 'Oui' }
  ColoriZone (OuiX, OuiY, OuiLarg, OuiHaut, CoulF, Coul);

  { Colorie le 'Non' }
  ColoriZone (NonX, NonY, NonLarg, NonHaut, Coul, CoulF);

  DessineSouris;
end;

function Confirmation : boolean; var accord: boolean; begin
  EffaceSouris;

  { Repositionne la souris }
  with Souris do begin
    X := NonX +NonLarg shr 1;
    Y := NonY +NonHaut shr 1
  end;

  { Sauve le fond }
  LitZone (ConfirmX,ConfirmY, 100,50, Tampon);

  { Charge l' image de confiramtion (T'es sur -> Oui/Non) }
  AffichePcx (ConfirmX,ConfirmY,'OuiNon');

  DessineSouris;

  accord := NON;
  repeat
    LitSouris;

    if  (OuiX<=souris.x) and (souris.x<=OuiX+OuiLarg)
    and (OuiY<=souris.y) and (souris.y<=OuiY+OuiHaut) and (accord=NON) then begin
      accord := OUI;
      Coloriz (accord);
    end;

    if  (NonX<=souris.x) and (souris.x<=NonX+NonLarg)
    and (NonY<=souris.y) and (souris.y<=NonY+NonHaut) and (accord=OUI) then begin
      accord := NON;
      Coloriz (accord);
    end;
  until ( (souris.b1) and (OuiX<souris.x) and (souris.x<=NonX+NonLarg) and (OuiY<=souris.y) and (souris.y<=OuiY+OuiHaut))
         or TouchPresse;

  if TouchPresse then begin
    accord := UpCase(LitTouche)='O';
    Coloriz (accord);
  end;

  if Souris.B1 then AttendBoutonSouris (1);

  { Replace le fond }
  EffaceSouris;
  EcritZone (ConfirmX,ConfirmY, 100,50, Tampon);
  DessineSouris;

  Confirmation := accord;
end;

procedure DessineChar; var coul_bit: byte; iy2: word; begin
  AttendEcran; EffaceSouris;

  vram := GrdChrY*320 +GrdChrX; index := 0;
  for iy := 0 to 15 do begin
    coul := ord(Ascii[AsciiIndex][iy]);

    for ix := 0 to 7 do begin
      coul_bit := CoulCh[ ord(coul and MasqueB[ix]=MasqueB[ix]) ];

      { Dessine le grand caractre }
      RempliZoneOfs (Vram, 8,8, coul_bit);

      { Dessine le petit caractre }
      PutPixel (PtiChrX+ix,PtiChrY+iy,coul_bit);

      inc (index); inc (vram,9);
    end;

    inc (vram,(320-8)*9);
  end;

  DessineSouris;
end;

procedure ChangeIndexAscii (index: byte); begin
  AttendEcran; EffaceSouris;
  AsciiIndex := index;
  str (index:3,txt);
  EcriVga (24,156, txt , noir,blanc);

  DessineSouris; DessineChar;
end;

procedure DecalIndexAscii (plus: integer); var tmp: integer; begin
  tmp := AsciiIndex+plus;
  if tmp<0   then tmp := 0;
  if 255<tmp then tmp := 255;
  if (tmp=AsciiIndex) then exit;

  AsciiIndex := tmp;str (tmp:3,txt);
  EcriVga (24,156, txt , noir,blanc);

  DessineChar;
end;

procedure ModifAscii (x,y: word; NouvCoul : boolean); begin
  Ascii[AsciiIndex][y] := Ascii [AsciiIndex][y] and (255-MasqueB[x]) +(MasqueB[x]*ord(NouvCoul));

  coul := CoulCh[ord(NouvCoul)];

  AttendEcran; EffaceSouris;

  PutPixel (X+80,Y+10, Coul);
  RempliZone (X*9 +2, Y*9 +2, 8,8, Coul);

  DessineSouris;
end;

procedure DessineFenetre (Titre: string); begin
  AttendEcran; EffaceSouris;

  { Sauve le fond }
  LitZone (SauvX,SauvY, SauvLarg, SauvHaut, Tampon);

  { Charge l' image de capture }
  AffichePcx (SauvX,SauvY,'EditSauv');
  EcriTsp (SauvTitrX,SauvTitrY,Titre,blanc);
end;

procedure FenetreErreur (Titre: string); begin
  EcriVga (SauvTitrX,SauvTitrY, titre ,blanc,noir);
end;

procedure EffaceFenetre; begin
  EcritZone (SauvX,SauvY, SauvLarg, SauvHaut, Tampon);
end;

procedure EcritNomFich (NomFich: string); begin
  { Si l'extendion (.fnt) est prsente, l'efface }
  txt := NomFichSansExt(NomFich);
  while length(txt)<8 do txt := txt+' ';
  EcriVga (128,3,txt,blanc,NomFichCoulFond);
end;

Function ChargeFnt (NomFich: string) : word; begin
  erreur := OuvreFichier (F,0,NomFich,'fnt');

  if erreur=0 then begin
    BlockRead (F,EnTete,SizeOf(EnTeteFNT));

    with EnteteFntOk do begin
      { 'FNT' }
      if (EnTete.ID[0]<>ID[0]) or (EnTete.ID[1]<>ID[1]) or (EnTete.ID[2]<>ID[2]) then
      begin ChargeFnt := 200; exit end;

      { Version }
      if (Entete.Version<>Version) then
      begin ChargeFnt := 201; exit end;

      { Taille }
      if (Entete.Largeur<>Largeur) or (Entete.Hauteur<>Hauteur) then
      begin ChargeFnt := 202; exit end;

      { Nombre de couleurs }
      if (Entete.BitParPixel<>BitParPixel) then
      begin ChargeFnt := 203; exit; end;
    end;
  end;

  if erreur=0 then begin
    BlockRead(f,Ascii,4096);
    Close (f);
    ChargeFnt := 0;
  end else ChargeFnt := erreur;
end;

procedure SauveFnt (var NomFich: string); begin
  if NomFich='' then exit;

  CreeFichier (F, NomFich);

  BlockWrite (f,EnTeteFntOk,SizeOf(EnTeteFnt));
  BlockWrite (f,Ascii,SizeOf(Ascii));

  Close(f);
end;

procedure CaptureNomFich; begin
  Txt := ''; key := #0;
  repeat
    if TouchPresse then begin
      Key := UpCase (LitTouche);

      Case Key of
      { Efface '<---' }
      #8: if Txt[0]<>#0 then begin
        Delete(Txt,length(Txt),1);
        EcriVga (SauvNomX+length(Txt) shl 3,SauvNomY,'',SauveCoulFond,blanc);
      end;

      { Suppression }
      #211: if Txt[0]<>#0 then begin
        Delete(Txt,1,1);
        EcriVga (SauvNomX,SauvNomY,Txt+' ',blanc,SauveCoulFond);
      end;

      { A .. Z - 0..9 - '_' }
      'A'..'Z','0'..'9','_' :
      if Txt[0]<>#8 then begin
        Txt:=Txt+Key;
        EcriTsp (SauvNomX,SauvNomY,Txt,blanc);
      end;

      end; { de 'Case Key of' }
    end; { de 'if TouchPresse then'  }
  until (Key=_ENTREE) or (Key=_ECHAPE);

  if key=_ECHAPE then begin txt := ''; exit end;

  { Ajoute l'extension }
  AjouteExtNomFich (txt,'fnt');
end;

procedure Ouvrir; begin
  DessineFenetre ('Ouvrir :');

  CaptureNomFich;

  if Txt<>'' then begin
    erreur := ChargeFnt (Txt);

    if erreur=0 then begin
      EffaceFenetre;
      NomFichCours := Txt; EcritNomFich (NomFichCours);
      ChangeIndexAscii (IndexDefaut);
    end else begin
      Case erreur of
        2: FenetreErreur ('Introuvable ');
        5: FenetreErreur ('Accs refus');
      200: FenetreErreur ('Type inconnu');
      201: FenetreErreur ('Movaise ver.');
      202: FenetreErreur ('Faus. taille');
      203: FenetreErreur ('N. couleurs!');
      else FenetreErreur ('Erreur !');
      end;

      LitTouche; EffaceFenetre;
      DessineSouris;
    end; { de 'if erreur=0' }
  end else begin
    EffaceFenetre;
    DessineSouris;
  end;
end;

procedure SauverSous; begin
  DessineFenetre ('Sauver sous:');

  CaptureNomFich;

  if Txt<>'' then begin
    if FichierExistant(Txt)=OUI then begin
      AffichePcx (SauvX,SauvY,'EditSauv');
      EcriTsp (SauvTitrX,SauvTitrY,'Effacer O/N ?',rouge);
      FenetreErreur ('Effacer O/N?');
      EcriVga (SauvNomX,SauvNomY,'',noir,blanc);
      key := UpCase(LitTouche);
      if key='O' then erreur := 0 else erreur := 255;
    end else erreur := 0;

    if erreur=0 then begin
      SauveFnt (Txt);
      NomFichCours := Txt; EcritNomFich (Txt);
    end;
  end;

  EffaceFenetre; DessineSouris;
end;

procedure Sauver; begin
  if NomFichCours<>'' then begin
    if Confirmation then SauveFnt (NomFichCours)
  end else SauverSous;
end;

procedure Reinit; begin
  if not Confirmation then exit;

  Move (AsciiDemarrage[AsciiIndex],Ascii[AsciiIndex],16);
  DessineChar;
end;

procedure Rempli (NouvCoul: boolean); begin
  if not Confirmation then exit;

  if NouvCoul then coul := 255 else coul := 0;

  fillchar (ascii[AsciiIndex],16,coul);
  DessineChar;
end;

procedure Nouveau; begin
  if not Confirmation then exit;

  move (AsciiDemarrage,Ascii,256*16); ChangeIndexAscii (IndexDefaut);
  NomFichCours := ''; EcritNomFich ('sans nom');
end;

Procedure Copier; begin
  move (Ascii[AsciiIndex],SauveChr,SizeOf(Caract16x8));

  vram := PtiChrY*320 +PtiChrX;
  index := PtiChrCY*320 +PtiChrCX;
  for iy := 0 to 15 do begin
    move (Ecran^[vram],Ecran^[index],8);
    inc (vram,320);
    inc (index,320);
  end;
end;

Procedure Coller; begin
  if not Confirmation then exit;

  move (SauveChr,Ascii[AsciiIndex],SizeOf(Caract16x8));
  DessineChar;
end;

Procedure AfficheAide; begin
  EffaceEcran (noir);

  EcriVga ( 0, 0*8,'Touches de l''interface                  ',jaune,bleu);
  EcriTsp (-1, 2*8,'Ŀ',blanc);
  EcriTsp (-1, 3*8,' Gauche/Dr.   Change de caractre ',blanc);
  EcriTsp (-1, 4*8,' Haut/Bas     Idem mais 10 par 10 ',blanc);
  EcriTsp (-1, 5*8,' Dbut        Premier caractre   ',blanc);
  EcriTsp (-1, 6*8,' Fin          Dernier caractre   ',blanc);
  EcriTsp (-1, 7*8,'Ĵ',blanc);
  EcriTsp (-1, 8*8,' Touche "C"   Copier le caractre ',blanc);
  EcriTsp (-1, 9*8,' Touche "O"   Ouvrir une police   ',blanc);
  EcriTsp (-1,10*8,' Touche "R"   Reinitialise le car.',blanc);
  EcriTsp (-1,11*8,' Touche "S"   Sauve la police     ',blanc);
  EcriTsp (-1,12*8,' Touche "V"   Coller le caractre ',blanc);
  EcriTsp (-1,13*8,'Ĵ',blanc);
  EcriTsp (-1,14*8,' Echape       Quitter             ',blanc);
  EcriTsp (-1,15*8,'',blanc);

  EcriVga ( 0,17*8,'Touches de la fentre de confirmation   ',jaune,bleu);
  EcriTsp (-1,18*8,'Ŀ',blanc);
  EcriTsp (-1,19*8,' Touche "O"   Donne l''accord      ',blanc);
  EcriTsp (-1,20*8,' Touche "N"   Refus               ',blanc);
  EcriTsp (-1,21*8,'',blanc);

  EcriVga ( 0,192,'    Pressez une touche pour revenir     ',noir,gris);

  LitTouche;

  AffichePcx (0,0,'Edit16x8');                     { Charge l' image de fond }
  if NomFichCours='' then EcritNomFich ('sans non') else EcritNomFich (NomFichCours);
  DessineSouris;
  ChangeIndexAscii (IndexDefaut);
end;

function AsciiMisAJour : boolean; var Different: boolean; begin
  move (Ascii,SauveAscii,SizeOf(Ascii));

  if NomFichCours<>'' then
    i := ChargeFnt (NomFichCours)
  else
    move (AsciiDemarrage,Ascii,SizeOf(Ascii));

  i := 0; Different := FALSE;
  repeat
    ix := 0;
    repeat
      Different := (Ascii[i][ix]<>SauveAscii[i][ix]);
      inc (ix);
    until (ix=16) or Different;

    inc (i);
  until (i=256) or Different;

  move (SauveAscii,Ascii,SizeOf(Ascii));

  AsciiMisAJour := Different;
end;

Procedure Fin; begin
{$IFNDEF FinRapide}
  if Confirmation=NON then exit;
{$ENDIF}

  { Ascii modifi ? }
  if AsciiMisAJour then
    if NomFichCours='' then SauverSous else SauveFnt (NomFichCours);

{$IFNDEF FinRapide}
  { Fondu en fermeture (noir) }
  LitGrandePal (Pal, 0,256);
  for iy := 0 to 63 do begin
    ix := 0;
    for index := 0 to 255 do begin
      if Pal[ix]<>0 then dec (Pal[ix]); inc (ix);
      if Pal[ix]<>0 then dec (Pal[ix]); inc (ix);
      if Pal[ix]<>0 then dec (Pal[ix]); inc (ix);
    end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);
  end;
{$ENDIF}

  InitModeTxt; ChangePolice16x8 (Ascii);
  CurseurOff;
  AttendEcran;
  EcriTc ('Edit16x8',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne;

{$IFNDEF FinRapide}
  { Fondu en ouverture (blanc) }
  LitGrandePal (Tampon,0,256);
  fillchar (pal,SizeOf(pal),0); ChangeGrandePal (pal ,0,256);
  for iy := 0 to 63 do begin
    ix := 0;
    for index := 0 to 255 do begin
      if Pal[ix]<Tampon[ix] then inc (Pal[ix]); inc (ix);
      if Pal[ix]<Tampon[ix] then inc (Pal[ix]); inc (ix);
      if Pal[ix]<Tampon[ix] then inc (Pal[ix]); inc (ix);
    end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);
  end;
{$ENDIF}

  CurseurOn; Halt;
end;

procedure Bouton (x,y,largeur,hauteur : word; fonction: byte; periph: byte); begin
  if periph<>_CLAVIER then begin
    dec (hauteur); dec (largeur);

    { Bouton enfonce }
    AttendEcran; EffaceSouris;
    DessineLigneV (x,y+1,hauteur  ,gris); DessineLigneH (x+1,y+hauteur,largeur-1,blanc);
    DessineLigneH (x,  y,largeur+1,gris); DessineLigneV (x+largeur,y+1,hauteur,blanc);
    DessineSouris;

    { Attend la relache du bouton }
    AttendBoutonSouris (periph);

    { Bouton relach }
    AttendEcran; EffaceSouris;
    DessineLigneV (x,y+1,hauteur  ,blanc); DessineLigneH (x+1,y+hauteur,largeur-1,gris);
    DessineLigneH (x,  y,largeur+1,blanc); DessineLigneV (x+largeur,y+1,hauteur,gris);
    DessineSouris;
  end;

  case fonction of
  _CHANGM1 : DecalIndexAscii (-1);
  _CHANGM10: DecalIndexAscii (-10);
  _CHANGP1 : DecalIndexAscii (+1);
  _CHANGP10: DecalIndexAscii (+10);

  _NOUVEAU : Nouveau;
  _OUVRIR  : Ouvrir;
  _SAUVER  : Sauver;
  _SAUVSOUS: SauverSous;
  _COPIER  : Copier;
  _COLLER  : Coller;

  _EFFACE  : if periph<>_CLAVIER then Rempli (periph=_SOURIS_D);
  _DEFAUT  : Reinit;
  _QUITTER : Fin;
  end;
end;

procedure TestBouton (x,y,largeur,hauteur : word; fonction: byte; periph: byte); begin
  if  (x-1 < souris.x) and (souris.x < x+largeur)
  and (y-1 < souris.y) and (souris.y < y+hauteur) then
    Bouton (x, y, largeur, hauteur,  fonction, periph);
end;

procedure AnalyseSouris (bout : byte); begin
  { Bouton 'Change de code Ascii -1' }
  TestBouton ( 12,154,  8, 12,  _CHANGM1, bout);

  { Bouton 'Change de code Ascii -10' }
  TestBouton (  3,154,  8, 12,  _CHANGM10, bout);

  { Bouton 'Change de code Ascii +1' }
  TestBouton ( 52,154,  8, 12,  _CHANGP1, bout);

  { Bouton 'Change de code Ascii +10' }
  TestBouton ( 61,154,  8, 12,  _CHANGP10, bout);

  { Bouton 'nouveau' }
  TestBouton (299,  1, 20, 20,  _NOUVEAU, bout);

  { Bouton 'ouvrir' }
  TestBouton (299, 22, 20, 20,  _OUVRIR, bout);

  { Bouton 'enregistrer' }
  TestBouton (299, 43, 20, 20,  _SAUVER, bout);

  { Bouton 'enregistrer sous' }
  TestBouton (299, 64, 20, 20,  _SAUVSOUS, bout);

  { Bouton 'copier' }
  TestBouton (299, 90, 20, 20,  _COPIER, bout);

  { Bouton 'coller' }
  TestBouton (299,111, 20, 20,  _COLLER, bout);

  { Bouton 'efface le caractre en cours' }
  TestBouton (98, 132, 46, 13, _EFFACE, bout);

  { Bouton 'remet le caractere par defaut' }
  TestBouton (98, 117, 46, 13, _DEFAUT, bout);

  { Dernier 'Quitter' }
  TestBouton (299,199-20, 20, 20, _QUITTER, bout);

  { Dessine dans le cadre  }
  if (2<souris.x)  and (souris.x<73) and (2<souris.y) and (souris.y<145) then
    ModifAscii ((souris.x-2) div 9,(souris.y-2) div 9,CoulCours[bout]);
end;

procedure TraiteClavier; begin
  if TouchPresse=NON then exit;

  Key := UpCase (LitTouche);

  Case Key of
  { Ouvrir / Sauver la police actuelle }
  'O'    : Ouvrir;
  'S'    : Sauver;

  { Reinitialise }
  'R'    : Reinit;

  { Copier / Coller }
  'C'    : Copier;
  'V'    : Coller;

  { Aide }
  _F1    : AfficheAide;

  { Change de caractre }
  _GAUCHE: DecalIndexAscii ( -1);
  _DROITE: DecalIndexAscii ( +1);
  _HAUT  : DecalIndexAscii (+10);
  _BAS   : DecalIndexAscii (-10);
  _DEBUT : ChangeIndexAscii (0);
  _FIN   : ChangeIndexAscii (255);
  _ECHAPE: Fin;
  end;
end;

procedure TraiteSouris; begin
  LitSouris;

  if souris.b1 then
    AnalyseSouris(_SOURIS_G)
  else if souris.b2 then
    AnalyseSouris(_SOURIS_D);
end;

procedure Init; begin
  { Vrifie la prsence du pilote de la souris et de la souris }
  TestPresenceSouris;

  { Lit la police de caractre actuelle }
  LitPolice16x8 (AsciiDemarrage);

  { Passe en mode graphique }
  ModeVga256;                     { Mode VGA : 320x200 pixel en 256 couleurs }
  AffichePcx (0,0,'Edit16x8');                   { Affiche l' image de fond }

  CoulCh[0] := CouleurNoire;
  CoulCh[1] := CouleurBlanche;
  blanc := CouleurBlanche;
  noir := CouleurNoire;

  CoulCours[1] := OUI; CoulCours[2] := NON;
  NomFichCours := ''; EcritNomFich ('sans nom');   { Aucun nom de fichier }

  { Initialise la souris }
  InitSouris;
  DessineSouris;

  { Charge la table ASCII }
  move (AsciiDemarrage,Ascii,SizeOf(Ascii));
  ChangeIndexAscii (IndexDefaut);
end;

begin
  Init;

  repeat
    TraiteSouris;
    TraiteClavier;
  until FALSE;
end.